(function () {
    "use strict";

    angular.module('core').controller('pedidoCompraDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', '$q', '$alert', 'pedidoCompraService', 'lookupService', 'produtoService'];

    function controller($scope, $timeout, $state, $stateParams, $q, $alert, pedidoCompraService, lookupService, produtoService) {

        $scope.initializeLayout('Pedido Compra');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            exibir: {
                index: 2,
                enum: { entregue: 0, entregar: 1, total: 2, cancelada: 3 }
            }
        };

        $scope.save = function () {
            $scope.popups.addItem.save();
        };

        $scope.auxiliar = {
            fornecedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFornecedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            transportadora: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTransportadora({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tabelapreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            condicaopagamento: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCondicaoPagamento({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            naturezaoperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllNaturezaOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            endereco: {
                prepare: function (index) {
                    contatoService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                $scope.state.item.Enderecos[index] = response.Data;
                                $('[ng-model$="item.Linha2"]').focus();
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });
                },
                prepareNew: function () {
                    contatoService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                $scope.state.item = response.Data;
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });

                },
            }
        };

        $scope.popups =
            {
                addItem: {
                    ativo: false,
                    vazio: false,
                    itens: [],
                    filtro: {
                        codigo: '',
                        filtro: {
                            Status: 2
                        }
                    },
                    carregando: false,
                    itensAdicionado: [],
                    prepareItem: function () {
                        pedidoCompraService
                            .prepare({ pedidoCompra: $scope.state.item })
                            .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.popups.addItem.ativo = false;
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.addItem.ativo = false;
                                    $scope.state.item = response.Data;
                                    $scope.popups.addItem.filtro.codigo = '';
                                }
                            },
                            function (_error) {
                                $scope.popups.addItem.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                    },
                    save: function () {
                        $scope.popups.addItem.carregando = true;
                        pedidoCompraService
                            .save($scope.state.item)
                            .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.popups.addItem.carregando = false;
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.historyBack();
                                }
                            },
                            function (_error) {
                                $scope.popups.addItem.carregando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                    },

                    prepareNewItem: function () {
                        $scope.popups.addItem.carregando = true;
                        var args = {
                            codigo: $scope.popups.addItem.filtro.codigo,
                            pedidoCompra: $scope.state.item
                        }

                        pedidoCompraService
                            .prepareNewItem(args)
                            .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.addItem.carregando = false;
                                } else {
                                    $scope.popups.addItem.carregando = false;
                                    $scope.state.item = response.Data.PedidoCompra;
                                    $timeout(function () { $('[ng-model*="popups.addItem.filtro.codigo"]').focus(); });
                                    
                                    $scope.popups.addItem.ativo = true;

                                }
                            },
                            function (_error) {
                                $scope.popups.addItem.carregando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                    }
                }
            }

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            pedidoCompraService
                .get($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {

                        $scope.state.item = response.Data;
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = !$scope.state.item;
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.get();
        };

        $scope.initialize();

    }

})();